/* ---------------------------------------------------------------------
 * 
 * Giada - Your Hardcore Loopmachine 
 * 
 * ---------------------------------------------------------------------
 * 
 * Copyright (C) 2010-2012 Giovanni A. Zuliani | Monocasual
 * 
 * This file is part of Giada - Your Hardcore Loopmachine.
 * 
 * Giada - Your Hardcore Loopmachine is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * Giada - Your Hardcore Loopmachine is distributed in the hope that it 
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Giada - Your Hardcore Loopmachine. If not, see 
 * <http://www.gnu.org/licenses/>.
 * 
 * ------------------------------------------------------------------ */



#ifndef GD_ACTIONEDITOR_H
#define GD_ACTIONEDITOR_H

#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Scroll.H>
#include "ge_window.h"
#include "ge_actionChannel.h"
#include "ge_muteChannel.h"
#include "ge_mixed.h"
#include "gui_utils.h"
#include "mixer.h"
#include "recorder.h"




class gdActionEditor : public gWindow {

public:

	gdActionEditor(int chan);
	~gdActionEditor();

	static void cb_zoomIn(Fl_Widget *w, void *p);
	static void cb_zoomOut(Fl_Widget *w, void *p);
	inline void __cb_zoomIn();
	inline void __cb_zoomOut();

	class gClick         *zoomIn;
	class gClick         *zoomOut;
	class Fl_Scroll      *scroller;  
	class gActionChannel *ac;
	class gMuteChannel   *mc;

	int chan;
	int zoom;
	int framesPerBar;
	int framesPerBeat;
	int framesPerBeats;
	int totalFrames;
	int totalWidth;      
	int beatWidth;       
	int coverX; 					
};

#endif
